// This example draws a circle at the point you click in the frame.
// If the cursor is a wait cursor, then the click is ignored.

import java.awt.*;
class Main extends Frame implements Runnable {
    int curX, curY;

    Main() {
        super("getCursor Example");
        resize(200, 200);
        show();
        (new Thread(this)).start();
    }

    public void update(Graphics g) {
        g.fillOval(curX, curY, 20, 20);
    }

    public boolean mouseDown(Event evt, int x, int y) {
        if (getCursorType() != WAIT_CURSOR) {
            curX = x;
            curY = y;
            repaint();
        }
        return true;
    }

    public void run() {
        while (true) {
            try {
                if (getCursorType() == WAIT_CURSOR) {
                    setCursor(CROSSHAIR_CURSOR);
                } else {
                    setCursor(WAIT_CURSOR);
                }
                Thread.sleep(3000);
            } catch (InterruptedException e) {};
        }
    }

    static public void main(String[] args) {
        new Main();
    }
}
