import java.awt.*;
class Main extends Frame {
    Insets insets = new Insets(0, 0, 0, 0);

    Main() {
        super("Insets Example");
        resize(150, 150);
        show();
    }

    public void paint(Graphics g) {
        int w = size().width - insets().right-insets().left;
        int h = size().height - insets().bottom-insets().top;
        FontMetrics fm = g.getFontMetrics();
        
        g.fillRect(insets.left, insets.top, 
            w - insets.right - insets.left,
            h - insets.bottom - insets.top);
        g.setColor(Color.white);
        // top
        g.drawString("top", insets.left 
                + (w-insets.left-insets.right-fm.stringWidth("top"))/2, 
            insets.top+fm.getAscent());
        // left
        g.drawString("left", insets.left, 
                insets.top + (h-insets.top-insets.bottom-fm.getHeight())/2);
        // bottom
        g.drawString("bottom", insets.left 
                + (w-insets.left-insets.right-fm.stringWidth("bottom"))/2, 
            h-insets.bottom-fm.getDescent());
        // right
        g.drawString("right", w-insets.right-fm.stringWidth("right"), 
                insets.top + (h-insets.top-insets.bottom-fm.getHeight())/2);
    }

    public boolean keyDown(Event evt, int key) {
        key = Character.toLowerCase((char)key);
        switch (key) {
            case 't':
                if (evt.shiftDown()) {
                    if (insets.top > 0) {
                        insets.top--;
                    }
                } else {
                    insets.top++;
                }
                repaint();
                return true;
            case 'b':
                if (evt.shiftDown()) {
                    if (insets.bottom > 0) {
                        insets.bottom--;
                    }
                } else {
                    insets.bottom++;
                }
                repaint();
                return true;
            case 'l':
                if (evt.shiftDown()) {
                    if (insets.left > 0) {
                        insets.left--;
                    }
                } else {
                    insets.left++;
                }
                repaint();
                return true;
            case 'r':
                if (evt.shiftDown()) {
                    if (insets.right > 0) {
                        insets.right--;
                    }
                } else {
                    insets.right++;
                }
                repaint();
                return true;
        }
        return false;
    }

    public static void main(String[] args) {
        new Main();
    }
}
