import java.awt.*;
public class Main extends Frame {
    Label l = new Label();
    MainCanvas cv = new MainCanvas(l);

    Main() {
        super("Polygon Example");
        Panel p = new Panel();

        p.setLayout(new GridLayout(1, 0));
        p.add(new Button("New"));
        p.add(new Button("Flip Ver"));
        p.add(new Button("Flip Hor"));
        add("South", p);

        cv.resize(300, 300);
        add("Center", cv);
        add("North", l);
        pack();
        show();
    }
    
    public boolean action(Event evt, Object what) {
        if (evt.target instanceof Button) {
            if ("New".equals(what)) {
                cv.polygon = null;
            } else if (cv.polygon != null) {
                boolean ver =  "Flip Ver".equals(what);
                Rectangle r = cv.polygon.getBoundingBox();

                r.add(0, 0);
                for (int i=0; i<cv.polygon.npoints; i++) {
                    if (ver) {
                        cv.polygon.ypoints[i] = r.height - cv.polygon.ypoints[i];
                    } else {
                        cv.polygon.xpoints[i] = r.width - cv.polygon.xpoints[i];
                    }
                }
            }
            cv.repaint();
            return true;
        }
        return false;
    }

    static public void main(String[] args) {
        new Main();
    }
}

class MainCanvas extends Canvas {
    Label label;
    Polygon polygon;

    MainCanvas(Label label) {
        this.label = label;
    }
    // Returns a random number in the range [0..r-1].
    int random(int r) {
        return (int)(Math.floor(Math.random()*r));
    }

    public void paint(Graphics g) {
        int w = size().width;
        int h = size().height;

        if (polygon == null) {
            polygon = new Polygon();
            for (int i=0; i<25; i++) {
                // Points need to be one pixel from the
                // right and bottom edges otherwise the polygon
                // will extend outside the canvas bounds.
                polygon.addPoint(random(w-1), random(h-1));
            }
        }
        g.fillPolygon(polygon);
    }

    public boolean mouseMove(Event evt, int x, int y) {
        if (polygon != null) {
            label.setText("inside: " + polygon.inside(x, y));
        }
        return true;
    }

}
