import java.awt.*;
import java.net.*;
class Main extends Frame {
    Main(String filename) {
        super("getImage Example");
        try {
            // Retrieve the image.
            URL url = new URL("file:///" + System.getProperty("user.dir")
               + "/" + filename);
            Image urlImage = getToolkit().getImage(url);

            add("Center", new ImageCanvas(urlImage));
        } catch (Exception e) {
            e.printStackTrace();
        }
        resize(50, 100);
        show();
    }

    static public void main(String[] args) {
        if (args.length == 1) {
            new Main(args[0]);
        } else {
            System.err.println("usage: java Main <image file>");
        }
    }
}

class ImageCanvas extends Canvas {
    Image image;

    ImageCanvas(Image image) {
        this.image = image;
    }

    public void paint(Graphics g) {
        update(g);
    }

    public void update(Graphics g) {
        g.drawImage(image, 0, 0, size().width, size().height, this);
    }
}

